<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_ServiceCategory ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_ServiceCategory extends AbstractStructArrayBase
{
    /**
     * The ServiceCategory
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_ServiceCategory[]
     */
    public $ServiceCategory;
    /**
     * Constructor method for ArrayOfJP_ServiceCategory
     * @uses ArrayOfJP_ServiceCategory::setServiceCategory()
     * @param \StructType\JP_ServiceCategory[] $serviceCategory
     */
    public function __construct(array $serviceCategory = array())
    {
        $this
            ->setServiceCategory($serviceCategory);
    }
    /**
     * Get ServiceCategory value
     * @return \StructType\JP_ServiceCategory[]|null
     */
    public function getServiceCategory()
    {
        return $this->ServiceCategory;
    }
    /**
     * This method is responsible for validating the values passed to the setServiceCategory method
     * This method is willingly generated in order to preserve the one-line inline validation within the setServiceCategory method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateServiceCategoryForArrayConstraintsFromSetServiceCategory(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_ServiceCategoryServiceCategoryItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_ServiceCategoryServiceCategoryItem instanceof \StructType\JP_ServiceCategory) {
                $invalidValues[] = is_object($arrayOfJP_ServiceCategoryServiceCategoryItem) ? get_class($arrayOfJP_ServiceCategoryServiceCategoryItem) : sprintf('%s(%s)', gettype($arrayOfJP_ServiceCategoryServiceCategoryItem), var_export($arrayOfJP_ServiceCategoryServiceCategoryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ServiceCategory property can only contain items of type \StructType\JP_ServiceCategory, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ServiceCategory value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_ServiceCategory[] $serviceCategory
     * @return \ArrayType\ArrayOfJP_ServiceCategory
     */
    public function setServiceCategory(array $serviceCategory = array())
    {
        // validation for constraint: array
        if ('' !== ($serviceCategoryArrayErrorMessage = self::validateServiceCategoryForArrayConstraintsFromSetServiceCategory($serviceCategory))) {
            throw new \InvalidArgumentException($serviceCategoryArrayErrorMessage, __LINE__);
        }
        $this->ServiceCategory = $serviceCategory;
        return $this;
    }
    /**
     * Add item to ServiceCategory value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_ServiceCategory $item
     * @return \ArrayType\ArrayOfJP_ServiceCategory
     */
    public function addToServiceCategory(\StructType\JP_ServiceCategory $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_ServiceCategory) {
            throw new \InvalidArgumentException(sprintf('The ServiceCategory property can only contain items of type \StructType\JP_ServiceCategory, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ServiceCategory[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_ServiceCategory|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_ServiceCategory|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_ServiceCategory|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_ServiceCategory|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_ServiceCategory|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ServiceCategory
     */
    public function getAttributeName()
    {
        return 'ServiceCategory';
    }
}
